/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.unis.grainReserves.modular.basicWarehouse.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.unis.common.enums.CommonSortOrderEnum;
import com.unis.common.exception.CommonException;
import com.unis.common.page.CommonPageRequest;
import com.unis.grainReserves.modular.basicWarehouse.entity.BasicWarehouse;
import com.unis.grainReserves.modular.basicWarehouse.mapper.BasicWarehouseMapper;
import com.unis.grainReserves.modular.basicWarehouse.param.BasicWarehouseAddParam;
import com.unis.grainReserves.modular.basicWarehouse.param.BasicWarehouseEditParam;
import com.unis.grainReserves.modular.basicWarehouse.param.BasicWarehouseIdParam;
import com.unis.grainReserves.modular.basicWarehouse.param.BasicWarehousePageParam;
import com.unis.grainReserves.modular.basicWarehouse.service.BasicWarehouseService;

import java.util.List;

/**
 * 库中仓房下的货位信息Service接口实现类
 *
 * @author hjc
 * @date  2024/05/19 21:52
 **/
@Service
public class BasicWarehouseServiceImpl extends ServiceImpl<BasicWarehouseMapper, BasicWarehouse> implements BasicWarehouseService {

    @Override
    public Page<BasicWarehouse> page(BasicWarehousePageParam basicWarehousePageParam) {
        QueryWrapper<BasicWarehouse> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isAllNotEmpty(basicWarehousePageParam.getSortField(), basicWarehousePageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(basicWarehousePageParam.getSortOrder());
            queryWrapper.orderBy(true, basicWarehousePageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(basicWarehousePageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByAsc(BasicWarehouse::getWarehouseId);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(BasicWarehouseAddParam basicWarehouseAddParam) {
        BasicWarehouse basicWarehouse = BeanUtil.toBean(basicWarehouseAddParam, BasicWarehouse.class);
        this.save(basicWarehouse);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(BasicWarehouseEditParam basicWarehouseEditParam) {
        BasicWarehouse basicWarehouse = BeanUtil.toBean(basicWarehouseEditParam, BasicWarehouse.class);
        this.updateById(basicWarehouse);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<BasicWarehouseIdParam> basicWarehouseIdParamList) {
        // 执行删除
    }

    @Override
    public BasicWarehouse detail(BasicWarehouseIdParam basicWarehouseIdParam) {

        return null;
    }

    @Override
    public BasicWarehouse queryEntity(String id) {
        BasicWarehouse basicWarehouse = this.getById(id);
        if(ObjectUtil.isEmpty(basicWarehouse)) {
            throw new CommonException("库中仓房下的货位信息不存在，id值为：{}", id);
        }
        return basicWarehouse;
    }
}
